/*
 * Copyright (c) 2020 Raspberry Pi (Trading) Ltd.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

// -----------------------------------------------------
// NOTE: THIS HEADER IS ALSO INCLUDED BY ASSEMBLER SO
//       SHOULD ONLY CONSIST OF PREPROCESSOR DIRECTIVES
// -----------------------------------------------------

// This header may be included by other board headers as "boards/pico.h"

#ifndef _BOARDS_PICO_H
#define _BOARDS_PICO_H

// For board detection
#define RASPBERRYPI_PICO

// --- UART ---
// #ifndef PICO_DEFAULT_UART
// #define PICO_DEFAULT_UART 0
// #endif
// #ifndef PICO_DEFAULT_UART_TX_PIN
// #define PICO_DEFAULT_UART_TX_PIN 0
// #endif
// #ifndef PICO_DEFAULT_UART_RX_PIN
// #define PICO_DEFAULT_UART_RX_PIN 1
// #endif

// --- LED ---
// #ifndef PICO_DEFAULT_LED_PIN
// #define PICO_DEFAULT_LED_PIN 25
// #endif
// no PICO_DEFAULT_WS2812_PIN

// --- I2C ---
// #ifndef PICO_DEFAULT_I2C
// #define PICO_DEFAULT_I2C 0
// #endif
// #ifndef PICO_DEFAULT_I2C_SDA_PIN
// #define PICO_DEFAULT_I2C_SDA_PIN 4
// #endif
// #ifndef PICO_DEFAULT_I2C_SCL_PIN
// #define PICO_DEFAULT_I2C_SCL_PIN 5
// #endif

// --- SPI ---
// #ifndef PICO_DEFAULT_SPI
// #define PICO_DEFAULT_SPI 0
// #endif
// #ifndef PICO_DEFAULT_SPI_SCK_PIN
// #define PICO_DEFAULT_SPI_SCK_PIN 18
// #endif
// #ifndef PICO_DEFAULT_SPI_TX_PIN
// #define PICO_DEFAULT_SPI_TX_PIN 19
// #endif
// #ifndef PICO_DEFAULT_SPI_RX_PIN
// #define PICO_DEFAULT_SPI_RX_PIN 16
// #endif
// #ifndef PICO_DEFAULT_SPI_CSN_PIN
// #define PICO_DEFAULT_SPI_CSN_PIN 17
// #endif

// --- FLASH ---

//TODO: Figure out how to make the W25Q128 work:
#define PICO_BOOT_STAGE2_CHOOSE_W25Q080 1
// #define PICO_BOOT_STAGE2_CHOOSE_GENERIC_03H 1

#ifndef PICO_FLASH_SPI_CLKDIV
#define PICO_FLASH_SPI_CLKDIV 2
#endif

#ifndef PICO_FLASH_SIZE_BYTES
#define PICO_FLASH_SIZE_BYTES (128/8 * 1024 * 1024)
#endif

// Drive high to force power supply into PWM mode (lower ripple on 3V3 at light loads)
#define PICO_SMPS_MODE_PIN 23

// Sadly we got a new-old batch of B0's
// #ifndef PICO_FLOAT_SUPPORT_ROM_V1
// #define PICO_FLOAT_SUPPORT_ROM_V1 1
// #endif

// #ifndef PICO_DOUBLE_SUPPORT_ROM_V1
// #define PICO_DOUBLE_SUPPORT_ROM_V1 1
// #endif

#endif
